#ifndef GROUNDITEMS_HPP_INCLUDED
#define GROUNDITEMS_HPP_INCLUDED

#include "../../Game/Interactable/GroundItem.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

namespace GroundItems
{
    std::vector<Interactable::GroundItem> GetAllWithin(std::int32_t Distance);

    std::vector<Interactable::GroundItem> GetAll();
    std::vector<Interactable::GroundItem> GetAll(const Tile& T);
    std::vector<Interactable::GroundItem> GetAll(std::int32_t ID, std::int32_t Distance = -1);
    std::vector<Interactable::GroundItem> GetAll(const std::string& Name, std::int32_t Distance = -1);
    std::vector<Interactable::GroundItem> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    std::vector<Interactable::GroundItem> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    std::vector<Interactable::GroundItem> GetAll(const std::function<bool (Interactable::GroundItem&)>& Filter, std::int32_t Distance = -1);

    Interactable::GroundItem Get(const Tile& T);
    Interactable::GroundItem Get(std::int32_t ID, std::int32_t Distance = -1);
    Interactable::GroundItem Get(const std::string& Name, std::int32_t Distance = -1);
    Interactable::GroundItem Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    Interactable::GroundItem Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    Interactable::GroundItem Get(const std::function<bool (Interactable::GroundItem&)>& Filter, std::int32_t Distance = -1);
}

#endif // GROUNDITEMS_HPP_INCLUDED
